LeetCode-Distinct Subsequences(JAVA)

Given a string S and a string T, count the number of distinct subsequences of S which equals T.

A subsequence of a string is a new string which is formed from the original string by deleting some (can be none) of the characters without disturbing the relative positions of the remaining characters. (ie, “ACE” is a subsequence of “ABCDE” while “AEC” is not).

Example 1:

Input: S = “rabbbit”, T = “rabbit”
Output: 3
Explanation:

As shown below, there are 3 ways you can generate “rabbit” from S.
(The caret symbol ^ means the chosen letters)

rabbbit
^^^^ ^^
rabbbit
^^ ^^^^
rabbbit
^^^ ^^^
Example 2:

Input: S = “babgbag”, T = “bag”
Output: 5
Explanation:

As shown below, there are 5 ways you can generate “bag” from S.
(The caret symbol ^ means the chosen letters)

babgbag
^^ ^
babgbag
^^ ^
babgbag
^ ^^
babgbag
^ ^^
babgbag
^^^

说明:定义dp[i][j]为s的前i个字符转化为t的前j个字符的数量,
因为可以删除s的字符,所以首先可以得到dp[i][j] += dp[i - 1][j],当s[i - 1]==t[j - 1]时,dp[i][j] += dp[i - 1][j - 1]

class Solution {
    public int numDistinct(String s, String t) {
        int n1 = s.length();
        int n2 = t.length();
        
        int[][] dp = new int[n1 + 1][n2 + 1];
        dp[0][0] = 1;
        
        for(int i = 1; i < n1 + 1; i++) {
            dp[i][0] = 1;
        }
        
        for(int i = 1; i < n1 + 1; i++) {
            for(int j = 1; j < n2 + 1; j++) {
                
                if(s.charAt(i - 1) == t.charAt(j - 1)) {
                   dp[i][j] = dp[i][j] + dp[i - 1][j - 1];
                }
                dp[i][j] = dp[i][j] + dp[i - 1][j];
            }        
        }
        return dp[n1][n2];
    }
}
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值